--- config/c-library.m4.orig	2014-08-18 14:10:36.733016131 -0400
+++ config/c-library.m4	2014-08-19 16:56:13.243195582 -0400
@@ -367,3 +367,152 @@ if test "$pgac_cv_type_locale_t" = 'yes
   AC_DEFINE(LOCALE_T_IN_XLOCALE, 1,
             [Define to 1 if `locale_t' requires <xlocale.h>.])
 fi])])# PGAC_HEADER_XLOCALE
+
+
+# PGAC_FUNC_AIO_ATOMIC_BUILTIN_COMP_SWAP
+# ---------------------------------------
+# test whether this system has both the librt-style async io and the gcc atomic compare_and_swap
+#      and test operation of both,
+#      including verifying that aio_error can retrieve completion status
+#      of aio_read issued by a different process
+#
+AC_DEFUN([PGAC_FUNC_AIO_ATOMIC_BUILTIN_COMP_SWAP],
+[AC_MSG_CHECKING([whether have both librt-style async io and the gcc atomic compare_and_swap])
+AC_CACHE_VAL(pgac_cv_aio_atomic_builtin_comp_swap,
+pgac_save_LIBS=$LIBS
+LIBS=" -lrt $pgac_save_LIBS"
+[AC_TRY_RUN([#include <stdio.h>
+#include <unistd.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/mman.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <sys/wait.h>
+#include <fcntl.h>
+#include "aio.h"
+#include <errno.h>
+
+char *shmem;
+
+/*  returns rc of aio_read or -1 if some error */
+int
+processA(void)
+{
+	int fd , rc;
+	struct aiocb *aiocbp = (struct aiocb *) shmem;
+	char *buf = shmem + sizeof(struct aiocb);
+
+	rc = fd = open("configure", O_RDONLY );
+	if (fd != -1) {
+
+            memset(aiocbp, 0, sizeof(struct aiocb));
+            aiocbp->aio_fildes = fd;
+            aiocbp->aio_offset = 0;
+            aiocbp->aio_buf = buf;
+            aiocbp->aio_nbytes = 8;
+            aiocbp->aio_reqprio = 0;
+            aiocbp->aio_sigevent.sigev_notify = SIGEV_NONE;
+
+            rc = aio_read(aiocbp);
+	}
+        return rc;
+}
+
+/*  returns result of aio_error  -  0 if io completed successfully */
+int
+processB(void)
+{
+	struct aiocb *aiocbp = (struct aiocb *) shmem;
+	const struct aiocb * const pl[1] = { aiocbp };
+	int rv;
+	int	returnCode;
+        struct timespec my_timeout = { 0 , 10000 };
+        int max_iters , max_polls;
+
+	rv = aio_error(aiocbp);
+        max_iters = 100;
+        while ( (max_iters-- > 0) && (rv == EINPROGRESS) ) {
+                max_polls = 256;
+                my_timeout.tv_sec = 0; my_timeout.tv_nsec = 10000;
+                returnCode = aio_suspend(pl , 1 , &my_timeout);
+                while ((returnCode < 0) && (EAGAIN == errno) && (max_polls-- > 0)) {
+                    my_timeout.tv_sec = 0; my_timeout.tv_nsec = 10000;
+                    returnCode = aio_suspend(pl , 1 , &my_timeout);
+                }
+                rv = aio_error(aiocbp);
+        }
+
+	return rv;
+}
+
+int main (int argc, char *argv[])
+ {
+   int rc;
+   int pidB;
+   int child_status;
+   struct aiocb volatile * first_aiocb;
+   struct aiocb volatile * second_aiocb;
+   struct aiocb volatile * my_aiocbp = (struct aiocb *)20000008;
+
+   first_aiocb = (struct aiocb *)20000008;
+   second_aiocb = (struct aiocb *)40000008;
+
+   /*  first test  --  __sync_bool_compare_and_swap
+   **  set zero as success if two comp-swaps both worked as expected -
+   **  first compares equal and swaps,  second compares unequal
+   */
+   rc = (__sync_bool_compare_and_swap (&my_aiocbp, first_aiocb, second_aiocb));
+   if (rc) {
+      rc = (__sync_bool_compare_and_swap (&my_aiocbp, first_aiocb, second_aiocb));
+   } else {
+      rc = -1;
+   }
+
+   if (rc == 0) {
+       /*  second test  --  process A start aio_read
+       **  and process B checks completion by polling
+       */
+        rc = -1; /* pessimistic */
+
+	shmem = mmap(NULL, sizeof(struct aiocb) + 2048,
+				 PROT_READ | PROT_WRITE, MAP_SHARED | MAP_ANONYMOUS,
+				 -1, 0);
+	if (shmem != MAP_FAILED) {
+            
+            /*
+             * Start the I/O request in parent process, then fork and try to wait
+             * for it to finish from the child process.
+             */
+            rc = processA();
+            if (rc >= 0) {
+
+                rc = pidB = fork();
+                if (pidB != -1) {
+                    if (pidB != 0) {
+                        /* parent */
+                        wait (&child_status);
+                        if (WIFEXITED(child_status)) {
+                            rc = WEXITSTATUS(child_status);
+                        }
+                    } else {
+                        /* child */
+                        rc = processB();
+                        exit(rc);
+                    }
+                }
+            }
+        }
+   }
+
+   return rc;
+}],
+[pgac_cv_aio_atomic_builtin_comp_swap=yes],
+[pgac_cv_aio_atomic_builtin_comp_swap=no],
+[pgac_cv_aio_atomic_builtin_comp_swap=cross])
+])dnl AC_CACHE_VAL
+AC_MSG_RESULT([$pgac_cv_aio_atomic_builtin_comp_swap])
+if test x"$pgac_cv_aio_atomic_builtin_comp_swap" != x"yes"; then
+LIBS=$pgac_save_LIBS
+fi
+])# PGAC_FUNC_AIO_ATOMIC_BUILTIN_COMP_SWAP
--- src/backend/postmaster/postmaster.c.orig	2014-08-18 14:10:36.925017033 -0400
+++ src/backend/postmaster/postmaster.c	2014-08-19 16:56:13.315195840 -0400
@@ -123,6 +123,11 @@
 #include "storage/spin.h"
 #endif
 
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+void ReportFreeBAiocbs(void);
+int CountInuseBAiocbs(void);
+extern int hwmBufferAiocbs;         /*  high water mark of in-use  BufferAiocbs in pool           */
+#endif /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 
 /*
  * Possible types of a backend. Beyond being the possible bkend_type values in
@@ -1489,9 +1494,15 @@ ServerLoop(void)
 	fd_set		readmask;
 	int			nSockets;
 	time_t		now,
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+                           count_baiocb_time,
+#endif /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 				last_touch_time;
 
 	last_touch_time = time(NULL);
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+        count_baiocb_time = time(NULL);
+#endif /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 
 	nSockets = initMasks(&readmask);
 
@@ -1650,6 +1661,19 @@ ServerLoop(void)
 			last_touch_time = now;
 		}
 
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+                /*   maintain the hwm of used baiocbs every 10 seconds  */
+		if ((now - count_baiocb_time) >= 10)
+		{
+                        int inuseBufferAiocbs;         /*  current in-use  BufferAiocbs in pool */
+                        inuseBufferAiocbs = CountInuseBAiocbs();
+                        if (inuseBufferAiocbs > hwmBufferAiocbs) {
+			    hwmBufferAiocbs = inuseBufferAiocbs;
+			}
+			count_baiocb_time = now;
+		}
+#endif /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
 		/*
 		 * If we already sent SIGQUIT to children and they are slow to shut
 		 * down, it's time to send them SIGKILL.  This doesn't happen
@@ -3440,6 +3464,9 @@ PostmasterStateMachine(void)
 						signal_child(PgStatPID, SIGQUIT);
 				}
 			}
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+                        ReportFreeBAiocbs();
+#endif /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 		}
 	}
 
--- src/backend/executor/nodeBitmapHeapscan.c.orig	2014-08-18 14:10:36.869016769 -0400
+++ src/backend/executor/nodeBitmapHeapscan.c	2014-08-19 16:56:13.375196054 -0400
@@ -34,6 +34,8 @@
  *		ExecEndBitmapHeapScan		releases all storage.
  */
 #include "postgres.h"
+#include <sys/types.h> 
+#include <unistd.h>
 
 #include "access/relscan.h"
 #include "access/transam.h"
@@ -47,6 +49,10 @@
 #include "utils/snapmgr.h"
 #include "utils/tqual.h"
 
+#ifdef USE_PREFETCH
+extern unsigned int prefetch_dbOid; /*  database oid of relations on which prefetching to be done - 0 means all */
+extern unsigned int prefetch_bitmap_scans; /*  boolean whether to prefetch bitmap heap scans         */
+#endif   /* USE_PREFETCH */
 
 static TupleTableSlot *BitmapHeapNext(BitmapHeapScanState *node);
 static void bitgetpage(HeapScanDesc scan, TBMIterateResult *tbmres);
@@ -111,10 +117,21 @@ BitmapHeapNext(BitmapHeapScanState *node
 		node->tbmres = tbmres = NULL;
 
 #ifdef USE_PREFETCH
-		if (target_prefetch_pages > 0)
-		{
+		if (    prefetch_bitmap_scans
+                     && (target_prefetch_pages > 0)
+                     && (    (   (prefetch_dbOid > 0)
+                               && (prefetch_dbOid == scan->rs_rd->rd_node.dbNode)
+                             )
+                         ||  (prefetch_dbOid == 0)
+                        )
+                        /* sufficient number of blocks - at least twice the target_prefetch_pages */
+                     && (scan->rs_nblocks > (2*target_prefetch_pages))
+                   ) {
 			node->prefetch_iterator = prefetch_iterator = tbm_begin_iterate(tbm);
 			node->prefetch_pages = 0;
+                        if (prefetch_iterator) {
+                          tbm_zero(prefetch_iterator);  /* zero list of prefetched and unread blocknos */
+                        }
 			node->prefetch_target = -1;
 		}
 #endif   /* USE_PREFETCH */
@@ -138,12 +155,14 @@ BitmapHeapNext(BitmapHeapScanState *node
 			}
 
 #ifdef USE_PREFETCH
+                        if (prefetch_iterator) {
 			if (node->prefetch_pages > 0)
 			{
 				/* The main iterator has closed the distance by one page */
 				node->prefetch_pages--;
+                                tbm_subtract(prefetch_iterator, tbmres->blockno); /* remove this blockno from list of prefetched and unread blocknos */
 			}
-			else if (prefetch_iterator)
+                            else
 			{
 				/* Do not let the prefetch iterator get behind the main one */
 				TBMIterateResult *tbmpre = tbm_iterate(prefetch_iterator);
@@ -151,6 +170,7 @@ BitmapHeapNext(BitmapHeapScanState *node
 				if (tbmpre == NULL || tbmpre->blockno != tbmres->blockno)
 					elog(ERROR, "prefetch and main iterators are out of sync");
 			}
+                        }
 #endif   /* USE_PREFETCH */
 
 			/*
@@ -239,16 +259,26 @@ BitmapHeapNext(BitmapHeapScanState *node
 			while (node->prefetch_pages < node->prefetch_target)
 			{
 				TBMIterateResult *tbmpre = tbm_iterate(prefetch_iterator);
+                                int             PrefetchBufferRc; /*  return value from PrefetchBuffer  - refer to bufmgr.h */
+
 
 				if (tbmpre == NULL)
 				{
 					/* No more pages to prefetch */
-					tbm_end_iterate(prefetch_iterator);
-					node->prefetch_iterator = prefetch_iterator = NULL;
+                                        /* let ExecEndBitmapHeapScan terminate the prefetch_iterator
+				        **	tbm_end_iterate(prefetch_iterator);
+					**      node->prefetch_iterator = NULL;
+                                        */
+                                        prefetch_iterator = NULL;
 					break;
 				}
 				node->prefetch_pages++;
-				PrefetchBuffer(scan->rs_rd, MAIN_FORKNUM, tbmpre->blockno);
+				PrefetchBufferRc = PrefetchBuffer(scan->rs_rd, MAIN_FORKNUM, tbmpre->blockno , 0);
+                                /*  add this blockno to list of prefetched and unread blocknos
+                                **  if pin count did not increase then indicate so in the Unread_Pfetched list
+                                */
+                                tbm_add(prefetch_iterator
+                                   ,( (PrefetchBufferRc & PREFTCHRC_BUF_PIN_INCREASED) ? tbmpre->blockno : InvalidBlockNumber ) );
 			}
 		}
 #endif   /* USE_PREFETCH */
@@ -482,12 +512,31 @@ ExecEndBitmapHeapScan(BitmapHeapScanStat
 {
 	Relation	relation;
 	HeapScanDesc scanDesc;
+	TBMIterator *prefetch_iterator;
 
 	/*
 	 * extract information from the node
 	 */
 	relation = node->ss.ss_currentRelation;
 	scanDesc = node->ss.ss_currentScanDesc;
+	prefetch_iterator = node->prefetch_iterator;
+
+#ifdef USE_PREFETCH
+        /*  before any other cleanup,  discard any prefetched but unread buffers  */
+        if (prefetch_iterator != NULL) {
+            TBMIterateResult *tbmpre = tbm_locate_IterateResult(prefetch_iterator);
+            BlockNumber *Unread_Pfetched_base = tbmpre->Unread_Pfetched_base;
+            unsigned int Unread_Pfetched_next = tbmpre->Unread_Pfetched_next;   /*  where the next unread blockno is relative to start */
+            unsigned int Unread_Pfetched_count = tbmpre->Unread_Pfetched_count;
+
+            while ((Unread_Pfetched_count--) > 0) {
+                DiscardBuffer( scanDesc->rs_rd, MAIN_FORKNUM, *(Unread_Pfetched_base+Unread_Pfetched_next));
+                Unread_Pfetched_next++;
+                if (Unread_Pfetched_next >= target_prefetch_pages)
+                    Unread_Pfetched_next = 0;
+            }
+        }
+#endif   /* USE_PREFETCH */
 
 	/*
 	 * Free the exprcontext
--- src/backend/executor/nodeIndexscan.c.orig	2014-08-18 14:10:36.869016769 -0400
+++ src/backend/executor/nodeIndexscan.c	2014-08-19 16:56:13.391196111 -0400
@@ -35,8 +35,13 @@
 #include "utils/rel.h"
 
 
+
 static TupleTableSlot *IndexNext(IndexScanState *node);
 
+#ifdef USE_PREFETCH
+extern unsigned int prefetch_dbOid; /*  database oid of relations on which prefetching to be done - 0 means all */
+extern unsigned int prefetch_index_scans; /*  boolean whether to prefetch bitmap heap scans         */
+#endif   /* USE_PREFETCH */
 
 /* ----------------------------------------------------------------
  *		IndexNext
@@ -418,7 +423,12 @@ ExecEndIndexScan(IndexScanState *node)
 	 * close the index relation (no-op if we didn't open it)
 	 */
 	if (indexScanDesc)
+        {
 		index_endscan(indexScanDesc);
+
+        /*  note  -  at this point all scan controlblock resources have been freed by IndexScanEnd called by index_endscan */
+
+        }
 	if (indexRelationDesc)
 		index_close(indexRelationDesc, NoLock);
 
@@ -609,6 +619,33 @@ ExecInitIndexScan(IndexScan *node, EStat
 											   indexstate->iss_NumScanKeys,
 											 indexstate->iss_NumOrderByKeys);
 
+#ifdef USE_PREFETCH
+        /*  initialize prefetching   */
+                indexstate->iss_ScanDesc->pfch_index_page_list =  (struct pfch_index_pagelist*)0;
+                indexstate->iss_ScanDesc->pfch_block_item_list = (struct pfch_block_item*)0;
+		if (    prefetch_index_scans
+			 && (target_prefetch_pages > 0)
+			 &&	(!RelationUsesLocalBuffers(indexstate->iss_ScanDesc->heapRelation)) /* I think this must always be true for an indexed heap ? */
+			 && (    (   (prefetch_dbOid > 0)
+					   && (prefetch_dbOid == indexstate->iss_ScanDesc->heapRelation->rd_node.dbNode)
+					 )
+				 ||  (prefetch_dbOid == 0)
+				)
+		   ) {
+			indexstate->iss_ScanDesc->pfch_index_page_list = palloc( sizeof(struct pfch_index_pagelist) + ( (target_prefetch_pages-1) * sizeof(struct pfch_index_item) ) );
+			indexstate->iss_ScanDesc->pfch_block_item_list = palloc( prefetch_index_scans * sizeof(struct pfch_block_item) );
+			if (     ( (struct pfch_index_pagelist*)0 != indexstate->iss_ScanDesc->pfch_index_page_list )
+                  && ( (struct pfch_block_item*)0 != indexstate->iss_ScanDesc->pfch_block_item_list )
+               ) {
+                          indexstate->iss_ScanDesc->pfch_used = 0;
+                          indexstate->iss_ScanDesc->pfch_next = prefetch_index_scans; /* ensure first entry is at index 0 */
+                          indexstate->iss_ScanDesc->pfch_index_page_list->pfch_index_pagelist_next = (struct pfch_index_pagelist*)0;
+                          indexstate->iss_ScanDesc->pfch_index_page_list->pfch_index_item_count = 0;
+                          indexstate->iss_ScanDesc->do_prefetch = 1;
+            }
+		}
+#endif   /* USE_PREFETCH */
+
 	/*
 	 * If no run-time keys to calculate, go ahead and pass the scankeys to the
 	 * index AM.
--- src/backend/executor/instrument.c.orig	2014-08-18 14:10:36.869016769 -0400
+++ src/backend/executor/instrument.c	2014-08-19 16:56:13.415196197 -0400
@@ -41,6 +41,14 @@ InstrAlloc(int n, int instrument_options
 		{
 			instr[i].need_bufusage = need_buffers;
 			instr[i].need_timer = need_timer;
+			instr[i].bufusage_start.aio_read_noneed = 0;
+			instr[i].bufusage_start.aio_read_discrd = 0;
+			instr[i].bufusage_start.aio_read_forgot = 0;
+			instr[i].bufusage_start.aio_read_noblok = 0;
+			instr[i].bufusage_start.aio_read_failed = 0;
+			instr[i].bufusage_start.aio_read_wasted = 0;
+			instr[i].bufusage_start.aio_read_waited = 0;
+			instr[i].bufusage_start.aio_read_ontime = 0;
 		}
 	}
 
@@ -143,6 +151,16 @@ BufferUsageAccumDiff(BufferUsage *dst,
 	dst->local_blks_written += add->local_blks_written - sub->local_blks_written;
 	dst->temp_blks_read += add->temp_blks_read - sub->temp_blks_read;
 	dst->temp_blks_written += add->temp_blks_written - sub->temp_blks_written;
+
+	dst->aio_read_noneed       += add->aio_read_noneed - sub->aio_read_noneed;
+	dst->aio_read_discrd       += add->aio_read_discrd - sub->aio_read_discrd;
+	dst->aio_read_forgot       += add->aio_read_forgot - sub->aio_read_forgot;
+	dst->aio_read_noblok       += add->aio_read_noblok - sub->aio_read_noblok;
+	dst->aio_read_failed       += add->aio_read_failed - sub->aio_read_failed;
+	dst->aio_read_wasted       += add->aio_read_wasted - sub->aio_read_wasted;
+	dst->aio_read_waited       += add->aio_read_waited - sub->aio_read_waited;
+	dst->aio_read_ontime       += add->aio_read_ontime - sub->aio_read_ontime;
+
 	INSTR_TIME_ACCUM_DIFF(dst->blk_read_time,
 						  add->blk_read_time, sub->blk_read_time);
 	INSTR_TIME_ACCUM_DIFF(dst->blk_write_time,
--- src/backend/storage/buffer/Makefile.orig	2014-08-18 14:10:36.933017070 -0400
+++ src/backend/storage/buffer/Makefile	2014-08-19 16:56:13.471196400 -0400
@@ -12,6 +12,6 @@ subdir = src/backend/storage/buffer
 top_builddir = ../../../..
 include $(top_builddir)/src/Makefile.global
 
-OBJS = buf_table.o buf_init.o bufmgr.o freelist.o localbuf.o
+OBJS = buf_table.o buf_init.o bufmgr.o freelist.o localbuf.o buf_async.o
 
 include $(top_srcdir)/src/backend/common.mk
